diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index f762196cbc..8e0bbd9a9f 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,5 +1,19 @@
 YYYY-MM-DD  Keith Seitz  <keiths@redhat.com>
 
+	* linespec.c (decode_compound_collector::decode_compound_collector):
+	Remove initialization for `m_symtabs'.
+	(decode_compound_collector::release_symbols): Change return type
+	to std::vector.  Update all callers.
+	(class decode_compound_collector) <m_symbols>: Change type to
+	std::vector.
+	(lookup_prefix_sym): Change return type to std::vector.  Update all
+	callers.
+	(find_method): Change `sym_classes' parameter to std::vector.
+	Update all callers.
+	(find_linespec_symbols): Remove cleanup.
+
+YYYY-MM-DD  Keith Seitz  <keiths@redhat.com>
+
 	* linespec.c (struct linespec) <minimal_symbols>: Change type to
 	std::vector.  Update all users.
 	(struct collect_info) <minimal_symbols>: Likewise.
diff --git a/gdb/linespec.c b/gdb/linespec.c
index bc20001df9..c3e5f484b8 100644
--- a/gdb/linespec.c
+++ b/gdb/linespec.c
@@ -3494,7 +3494,6 @@ class decode_compound_collector
 {
 public:
   decode_compound_collector ()
-    : m_symbols (NULL)
   {
     m_unique_syms = htab_create_alloc (1, htab_hash_pointer,
 				       htab_eq_pointer, NULL,
@@ -3507,12 +3506,10 @@ public:
       htab_delete (m_unique_syms);
   }
 
-  /* Releases ownership of the collected symbols and returns them.  */
-  VEC (symbolp) *release_symbols ()
+  /* Return all symbols collected.  */
+  std::vector<symbol *> release_symbols ()
   {
-    VEC (symbolp) *res = m_symbols;
-    m_symbols = NULL;
-    return res;
+    return m_symbols;
   }
 
   /* Callable as a symbol_found_callback_ftype callback.  */
@@ -3524,7 +3521,7 @@ private:
   htab_t m_unique_syms;
 
   /* The result vector.  */
-  VEC (symbolp) *m_symbols;
+  std::vector<symbol *>  m_symbols;
 };
 
 bool
@@ -3547,7 +3544,7 @@ decode_compound_collector::operator () (symbol *sym)
   if (!*slot)
     {
       *slot = sym;
-      VEC_safe_push (symbolp, m_symbols, sym);
+      m_symbols.push_back (sym);
     }
 
   return true; /* Continue iterating.  */
@@ -3557,7 +3554,7 @@ decode_compound_collector::operator () (symbol *sym)
 
 /* Return any symbols corresponding to CLASS_NAME in FILE_SYMTABS.  */
 
-static VEC (symbolp) *
+static std::vector<symbol *>
 lookup_prefix_sym (struct linespec_state *state,
 		   std::vector<symtab *> *file_symtabs,
 		   const char *class_name)
@@ -3696,11 +3693,9 @@ find_superclass_methods (std::vector<struct type *> &&superclasses,
 static void
 find_method (struct linespec_state *self, std::vector<symtab *> *file_symtabs,
 	     const char *class_name, const char *method_name,
-	     VEC (symbolp) *sym_classes, std::vector<symbol *> *symbols,
+	     std::vector<symbol *> *sym_classes, std::vector<symbol *> *symbols,
 	     std::vector<bound_minimal_symbol> *minsyms)
 {
-  struct symbol *sym;
-  int ix;
   size_t last_result_len;
   std::vector<struct type *> superclass_vec;
   std::vector<const char *> result_names;
@@ -3708,10 +3703,8 @@ find_method (struct linespec_state *self, std::vector<symtab *> *file_symtabs,
 
   /* Sort symbols so that symbols with the same program space are next
      to each other.  */
-  qsort (VEC_address (symbolp, sym_classes),
-	 VEC_length (symbolp, sym_classes),
-	 sizeof (symbolp),
-	 compare_symbols);
+  qsort (sym_classes->data (), sym_classes->size (),
+	 sizeof (symbol *), compare_symbols);
 
   info.state = self;
   info.file_symtabs = file_symtabs;
@@ -3728,7 +3721,8 @@ find_method (struct linespec_state *self, std::vector<symtab *> *file_symtabs,
      because we collect data across the program space before deciding
      what to do.  */
   last_result_len = 0;
-  for (ix = 0; VEC_iterate (symbolp, sym_classes, ix, sym); ++ix)
+  unsigned int ix = 0;
+  for (const auto &sym : *sym_classes)
     {
       struct type *t;
       struct program_space *pspace;
@@ -3744,10 +3738,9 @@ find_method (struct linespec_state *self, std::vector<symtab *> *file_symtabs,
 
       /* Handle all items from a single program space at once; and be
 	 sure not to miss the last batch.  */
-      if (ix == VEC_length (symbolp, sym_classes) - 1
+      if (ix == sym_classes->size () - 1
 	  || (pspace
-	      != SYMTAB_PSPACE (symbol_symtab (VEC_index (symbolp, sym_classes,
-							  ix + 1)))))
+	      != SYMTAB_PSPACE (symbol_symtab (sym_classes->at (ix + 1)))))
 	{
 	  /* If we did not find a direct implementation anywhere in
 	     this program space, consider superclasses.  */
@@ -3763,6 +3756,7 @@ find_method (struct linespec_state *self, std::vector<symtab *> *file_symtabs,
 
 	  superclass_vec.clear ();
 	  last_result_len = result_names.size ();
+	  ++ix;
 	}
     }
 
@@ -3952,7 +3946,6 @@ find_linespec_symbols (struct linespec_state *state,
     {
       std::string klass, method;
       const char *last, *p, *scope_op;
-      VEC (symbolp) *classes;
 
       /* See if we can find a scope operator and break this symbol
 	 name into namespaces${SCOPE_OPERATOR}class_name and method_name.  */
@@ -3981,18 +3974,16 @@ find_linespec_symbols (struct linespec_state *state,
       method = last;
 
       /* Find a list of classes named KLASS.  */
-      classes = lookup_prefix_sym (state, file_symtabs, klass.c_str ());
-      struct cleanup *old_chain
-	= make_cleanup (VEC_cleanup (symbolp), &classes);
-
-      if (!VEC_empty (symbolp, classes))
+      std::vector<symbol *> classes
+	= lookup_prefix_sym (state, file_symtabs, klass.c_str ());
+      if (!classes.empty ())
 	{
 	  /* Now locate a list of suitable methods named METHOD.  */
 	  TRY
 	    {
 	      find_method (state, file_symtabs,
 			   klass.c_str (), method.c_str (),
-			   classes, symbols, minsyms);
+			   &classes, symbols, minsyms);
 	    }
 
 	  /* If successful, we're done.  If NOT_FOUND_ERROR
@@ -4004,8 +3995,6 @@ find_linespec_symbols (struct linespec_state *state,
 	    }
 	  END_CATCH
 	}
-
-      do_cleanups (old_chain);
     }
 }
 